#include <StdFilePkg.h>
#include <HFS.h>
#include <ResourceMgr.h>
#include "Errors.h"
#include "Resources.h"

void InitError()
{
	CouldAlert(ERROR_ALRT);
	HNoPurge( GetResource( 'STR#', ERROR_STRS));
}

void Stat( ctrl, p1, p2, p3, p4)
	StringPtr ctrl;
	long p1,p2,p3,p4;
{
	Str255 buf;
	
	SPDrawF( buf, ctrl, p1, p2, p3, p4);
	
	ParamText( buf, 0L, 0L, 0L);
	StopAlert( ERROR_ALRT, 0L);
}

void Error( ind, p1, p2, p3, p4)
	int ind;
	long p1,p2,p3,p4;
{
	Str255 buf, ctrl;
	int i, end;
	
	GetIndString( ctrl, ERROR_STRS, ind);

	end = ctrl[0];								/* cvt to c string */
	for( i = 0; i<end; i++) ctrl[i] = ctrl[i+1];
	ctrl[end]=0;
	
	SPDrawF( buf, ctrl, p1, p2, p3, p4);
	
	ParamText( buf, 0L, 0L, 0L);
	StopAlert( ERROR_ALRT, 0L);
}

int	YesNo( ind, p1, p2, p3, p4)
	int ind;
	long p1,p2,p3,p4;
{
	Str255 buf, ctrl;
	int i, end;
	
	GetIndString( ctrl, YESNO_STRS, ind);

	end = ctrl[0];								/* cvt to c string */
	for( i = 0; i<end; i++) ctrl[i] = ctrl[i+1];
	ctrl[end]=0;
	
	SPDrawF( buf, ctrl, p1, p2, p3, p4);
	
	ParamText( buf, 0L, 0L, 0L);
	i = Alert( YESNO_ALRT, 0L);

	if ( i==1) return(1);
	else return(0);
}

int GetFile( n, v, t, pr)
	char *n, *pr;
	int *v;
	long t;
{
	SFReply sf;
	Point p;
	
	p.h = 100;
	p.v = 50;
	if ( pr != 0 && pr[0] != 0) {
		ParamText(pr,0L,0L,0L);
		SFPGetFile( p, pr, 0L, 1, &t, 0L, &sf, PROMPT_GETFILE_DLOG, 0L);
	} else {
		SFGetFile( p, pr, 0L, 1, &t, 0L, &sf);
	}
	if ( !sf.good) {
		*v = 0;
		*n = 0;
		return(0);
	}
	
	pstrcpy( n, sf.fName);
	*v = sf.vRefNum;
	return(1);
}

static unsigned char *suffix;
static pascal Boolean SuffixFilter( pb)
	FileParam *pb;
{
	unsigned char *s, *n, sc, nc;
	
	for( s = suffix; *s != 0; s++);
	s--;								/* s is end of suffix */
	
	for( n = pb->ioNamePtr + *pb->ioNamePtr; 
		 			n > pb->ioNamePtr && s >= suffix;
					n--, s--) {
		sc = *s;
		if ( sc >= 'a' && sc <= 'z') sc -= ('a' - 'A');
		nc = *n;
		if ( nc >= 'a' && nc <= 'z') nc -= ('a' - 'A');
		if ( nc != sc) return true;
	}
	return false;
}
int GetFileWithSuffix( n, v, t, pr, suf)
	char *n, *pr;
	int *v;
	long t;
	unsigned char *suf;
{
	SFReply sf;
	Point p;
	
	suffix = suf;
	p.h = 100;
	p.v = 150;
	if ( pr != 0 && pr[0] != 0) {
		ParamText(pr,0L,0L,0L);
		SFPGetFile( p, pr, SuffixFilter, 1, &t, 0L, &sf, PROMPT_GETFILE_DLOG, 0L);
	} else {
		SFGetFile( p, pr, 0L, 1, &t, 0L, &sf);
	}
	if ( !sf.good) {
		*v = 0;
		*n = 0;
		return(0);
	}
	
	pstrcpy( n, sf.fName);
	*v = sf.vRefNum;
	return(1);
}

int PutFile( n, v, pr)
	char *n, *pr;
	int *v;
{
	SFReply sf;
	Point p;
	
	p.h = 100;
	p.v = 50;
	SFPutFile( p, pr, n, 0L, &sf);
	if ( !sf.good) {
		*v = 0;
		*n = 0;
	}
	
	pstrcpy( n, sf.fName);
	*v = sf.vRefNum;
}

void	FullPathName( v, d, s, l)
	int v,d,l;
	char *s;
{
	int err;
	HFileInfo cpb;
	Str255 name;
	char parent[512];
	
	if ( v != d) {
		cpb.ioCompletion = 0;
		cpb.ioNamePtr = name;
		cpb.ioFDirIndex = -1;
		cpb.ioVRefNum = v;
		cpb.ioDirID = d;
		err = PBGetCatInfo( &cpb, false);
		if ( err != noErr) {
			FullPathName( v, cpb.ioFlParID, parent, 512);
			strncpy( s, parent, l);
			strncat( s, name, l);
			strncat( s, ":", l);
		}
	}
}

int		ReadString( r, i, s)
	int r, i;
	char *s;
{
	int old, stat;
	Handle sh;
	
	old = CurResFile();
	UseResFile(r);
	if ( ResError() != noErr) goto ReadStringError;
	
	sh = Get1Resource( 'STR ', i);
	if ( sh == 0) goto ReadStringError;
	
	pstrcpy( s, *sh);
	stat = true;
	ReleaseResource(sh);
	goto LeaveReadString;
	
ReadStringError:
	s[0] = 0;
	stat = false;

LeaveReadString:
	UseResFile(old);
	return(stat);
}

void	MakeTemp( base, vref, name, type, creator)
	char *base, *name;
	int		vref;
	long type, creator;
{
	FInfo finf;
	int i;
	int err;
	
	for ( i=1; ; i++) {
		SPDrawF( name, "%p_%d", base, i);
		err = GetFInfo( name, vref, &finf);
		if ( err == fnfErr) break;
		if ( err == noErr) continue;
		Error( fileErr, err);
	}
	SetVol( 0L, vref);
	CreateResFile( name);
	
	finf.fdType = type;
	finf.fdCreator = creator;
	finf.fdFlags = 0;
	SetFInfo( name, vref, &finf);
}

