
#include <QuickDraw.h>

char digits[] = "0123456789abcdef";

static char *_Cvt( v, b, p)
	long v;
	int b;
	char *p;
{
	register int i;
	
	if ( v==0L) return(p);
	p = _Cvt( v/b, b, p);
	i = v%b;
	if ( i<0 || i>15) DebugStr("\pI out of range in _Cvt");
	*p++ = digits[ i];
	return(p);
}

static char *Cvt( v, b, p)
	unsigned long v;
	int b;
	char *p;
{
	register int i;
	
	if ( v==0) {
		*p++ = '0';
		return(p);
	}
	if ( (long)v < 0L && b == 10) {
		v = -(long)v;
		*p++ = '-';
	}
	p = _Cvt( v/b, b, p);
	i = v%b;
	if ( i<0 || i>15) DebugStr("\pI out of range in Cvt");
	*p++ = digits[ i];
	return(p);
}

void SPDrawF( buf, format)
	char *buf, *format;
{
	register char *arg;
	register char *fpos, *opos, *spos;
	int i, num;
	int stop;
	
	arg = (char *)&format + 4;
	fpos = format;
	opos = buf+1;

	stop = 0;
	while( *fpos != 0 ) {
		if ( *fpos == '%') {
			fpos++;
			for ( num=0; *fpos >= '0' && *fpos <= '9'; fpos++) num = num*10 + *fpos - '0';
			
			if ( *fpos == '%') *opos++ = *fpos;
			else if (*fpos == 'm') {		/* move command */
			} else if (*fpos == 't') {		/* tab command */
			} else if (*fpos == 'n') {		/* newline command */
				*opos++ = '\n';
			} else if (*fpos == 'd') {
				opos = Cvt( (long) *(short *)arg, 10, opos);
				arg = arg + 2;
			} else if (*fpos == 'x') {
				opos = Cvt( (long) *(short *)arg, 16, opos);
				arg = arg + 2;
			} else if (*fpos == 'o') {
				opos = Cvt( (long) *(short *)arg,  8, opos);
				arg = arg + 2;
			} else if (*fpos == 'b') {
				opos = Cvt( (long) *(short *)arg,  2, opos);
				arg = arg + 2;
			} else if (*fpos == 'D') {
				opos = Cvt( (long) *(long *)arg, 10, opos);
				arg = arg + 4;
			} else if (*fpos == 'X') {
				opos = Cvt( (long) *(long *)arg, 16, opos);
				arg = arg + 4;
			} else if (*fpos == 'O') {
				opos = Cvt( (long) *(long *)arg,  8, opos);
				arg = arg + 4;
			} else if (*fpos == 'B') {
				opos = Cvt( (long) *(long *)arg,  2, opos);
				arg = arg + 4;
			} else if (*fpos == 's') {
				for ( spos = *(char **)arg; *spos != 0; ) *opos++ = *spos++;
				arg = arg+4;
			} else if (*fpos == 'c') {
				*opos++ = (char) *(short *)arg;
				arg = arg+2;
			} else if (*fpos == 'p') {
				spos = *(char **)arg + 1;
				for ( i  = **(unsigned char **)arg; i >0; i--) *opos++ = *spos++;
				arg = arg+4;
			} else {
			}
			fpos++;
		} else *opos++ = *fpos++;
	}
	*opos = 0;
	buf[0] = (long)opos - (long)buf - 1;
}

void SDrawF( buf, format)
	char *buf, *format;
{
	register char *arg;
	register char *fpos, *opos, *spos;
	int i, num;
	int stop;
	
	arg = (char *)&format + 4;
	fpos = format;
	opos = buf;

	stop = 0;
	while( *fpos != 0 ) {
		if ( *fpos == '%') {
			fpos++;
			for ( num=0; *fpos >= '0' && *fpos <= '9'; fpos++) num = num*10 + *fpos - '0';
			
			if ( *fpos == '%') *opos++ = *fpos;
			else if (*fpos == 'm') {		/* move command */
			} else if (*fpos == 't') {		/* tab command */
			} else if (*fpos == 'n') {		/* newline command */
				*opos++ = '\n';
			} else if (*fpos == 'd') {
				opos = Cvt( (long) *(short *)arg, 10, opos);
				arg = arg + 2;
			} else if (*fpos == 'x') {
				opos = Cvt( (long) *(short *)arg, 16, opos);
				arg = arg + 2;
			} else if (*fpos == 'o') {
				opos = Cvt( (long) *(short *)arg,  8, opos);
				arg = arg + 2;
			} else if (*fpos == 'b') {
				opos = Cvt( (long) *(short *)arg,  2, opos);
				arg = arg + 2;
			} else if (*fpos == 'D') {
				opos = Cvt( (long) *(long *)arg, 10, opos);
				arg = arg + 4;
			} else if (*fpos == 'X') {
				opos = Cvt( (long) *(long *)arg, 16, opos);
				arg = arg + 4;
			} else if (*fpos == 'O') {
				opos = Cvt( (long) *(long *)arg,  8, opos);
				arg = arg + 4;
			} else if (*fpos == 'B') {
				opos = Cvt( (long) *(long *)arg,  2, opos);
				arg = arg + 4;
			} else if (*fpos == 's') {
				for ( spos = *(char **)arg; *spos != 0; ) *opos++ = *spos++;
				arg = arg+4;
			} else if (*fpos == 'c') {
				*opos++ = (char) *(short *)arg;
				arg = arg+2;
			} else if (*fpos == 'p') {
				spos = *(char **)arg + 1;
				for ( i  = **(unsigned char **)arg; i >0; i--) *opos++ = *spos++;
				arg = arg+4;
			} else {
			}
			fpos++;
		} else *opos++ = *fpos++;
	}
	*opos = 0;
}

void DrawF( format)
	char *format;
{
	register char *arg;
	register char *fpos, *opos, *spos;
	int i;
	int stop, move;
	char drawBuf[1024];
	Point start;
	int h, line, num;
	FontInfo finf;
	GrafPtr currPort;
	
	GetPort( &currPort);
	
	arg = (char *)&format + 4;
	fpos = format;
	opos = drawBuf;

	start = currPort->pnLoc;
	GetFontInfo( &finf);
	line = finf.ascent + finf.leading + finf.descent;
	
	stop = 0; move = 0;
	while( !move && *fpos != 0 ) {
		if ( *fpos == '%') {
			fpos++;
			for ( num=0; *fpos >= '0' && *fpos <= '9'; fpos++) num = num*10 + *fpos - '0';
			
			if ( *fpos == '%') *opos++ = *fpos;
			else if (*fpos == 'm') {		/* move command */
				h = start.h + num;
				DrawText( drawBuf, 0, (long)opos - (long)drawBuf);
				MoveTo( h, start.v);
				opos = drawBuf;
			} else if (*fpos == 't') {		/* tab command */
				h = currPort->pnLoc.h + num;
				DrawText( drawBuf, 0, (long)opos - (long)drawBuf);
				MoveTo( h, start.v);
				opos = drawBuf;
			} else if (*fpos == 'n') {		/* newline command */
				DrawText( drawBuf, 0, (long)opos - (long)drawBuf);
				start.v += line;
				MoveTo( start.h, start.v);
				opos = drawBuf;
			} else if (*fpos == 'd') {
				opos = Cvt( (long) *(short *)arg, 10, opos);
				arg = arg + 2;
			} else if (*fpos == 'x') {
				opos = Cvt( (long) *(short *)arg, 16, opos);
				arg = arg + 2;
			} else if (*fpos == 'o') {
				opos = Cvt( (long) *(short *)arg,  8, opos);
				arg = arg + 2;
			} else if (*fpos == 'b') {
				opos = Cvt( (long) *(short *)arg,  2, opos);
				arg = arg + 2;
			} else if (*fpos == 'D') {
				opos = Cvt( (long) *(long *)arg, 10, opos);
				arg = arg + 4;
			} else if (*fpos == 'X') {
				opos = Cvt( (long) *(long *)arg, 16, opos);
				arg = arg + 4;
			} else if (*fpos == 'O') {
				opos = Cvt( (long) *(long *)arg,  8, opos);
				arg = arg + 4;
			} else if (*fpos == 'B') {
				opos = Cvt( (long) *(long *)arg,  2, opos);
				arg = arg + 4;
			} else if (*fpos == 's') {
				for ( spos = *(char **)arg; *spos != 0; ) *opos++ = *spos++;
				arg = arg+4;
			} else if (*fpos == 'c') {
				*opos++ = (char) *(short *)arg;
				arg = arg+2;
			} else if (*fpos == 'p') {
				spos = *(char **)arg + 1;
				for ( i  = **(unsigned char **)arg; i >0; i--) *opos++ = *spos++;
				arg = arg+4;
			} else {
			}
			fpos++;
		} else *opos++ = *fpos++;
	}
	*opos = 0;
	DrawText( drawBuf, 0, (long)opos - (long)drawBuf);
}
