/*
 * Auxilliary routines for BibTeX in C.
 *
 * Tim Morgan 2/15/88
 * Eduardo Krell 4/21/88
 */

#include <stdio.h>
#ifdef	BSD
#include <string.h>
#else
#include <strings.h>
#endif

#define TRUE 1
#define FALSE 0
#define filenamesize 1024

#include "bibtex.h"
extern char realnameoffile[];
extern char xord[], *buffer, nameoffile[];	/* change buffer for dyn alloc, jws */
char **gargv;
int gargc;

static char input_path[filenamesize];

FILE *openf(name, mode)
char *name, *mode;
{
    FILE *result;
/*
 *  Variables for directory search ... jdl  
 */
    int		refnum, cFolder, nPath, ferr;
    char	**PathHandle, *PathPtr;
    char	expand_name[100];
    FInfo	finder_info;
/*   done ... jdl  */

	{							/* ###### LSC doesn't like ./ (jws) */
		if ( name[0] == '.' && name[1] == '/') name += 2;
	}
/*
 *  Directory search stuff ... jdl
 */
 	PathHandle = (char **) GetResource('STR#', 130);    /* Path resource */
 	if (!PathHandle) {
 		printf("Path Resoucre not present!!!\n");
 		exit(1);
 	}
 	HLock(PathHandle);
 	PathPtr = *PathHandle;
 	nPath = *((int *) PathPtr);        /* # of path elements */
 	PathPtr += sizeof(int);
 	GetVol(MacVolumeName, Folders);    /*  current folder   */
 	while (nPath-- > 0) {
 		PtoCstr(PathPtr);
		cFolder = *PathPtr - '0';      /* which folder */
 		if (cFolder < 0 || cFolder > 2) {
 			printf("Invalid path decription %s\n", PathPtr);
 			exit(1);
 		}
 		
 		strcpy(expand_name, &PathPtr[1]);
 		strcat(expand_name, name);
		CtoPstr(expand_name);
		CtoPstr(PathPtr);
		ferr = FSOpen(expand_name, Folders[cFolder], &refnum);   /* see if the file is there */
		if (!ferr) break;
		PathPtr = PathPtr + *PathPtr + 1;   /* point at the next one */
	}
	
	HUnlock(PathHandle);
	
    if (ferr && mode[0] == 'r') {  /* old file not found */
    	printf("File %s not found\n",name);
    	perror(name);
		exit(1);
	}
	
	if (ferr) {   /* new file, put into same folder as aux file */
		strcpy(expand_name, name);
		CtoPstr(expand_name);
		cFolder = 0;
		ferr = Create(expand_name, Folders[0], AuxFileInfo.fdCreator, 'TEXT');
		if (ferr) {
			printf("Cound not create file %s error = %d\n", name, ferr);
			exit(1);
		}
	}
	FSClose(refnum);  /*  Yes we open the file twice....  */
	
	SetVol(0L, Folders[cFolder]);
	PtoCstr(expand_name);
    result = fopen(expand_name, mode);   /* Do the stdio file open */
    if (!result) {
    	printf("Problem openning file %s\n", name);
    	perror(name);
    	exit(1);
    }
    SetVol(0L, Folders[0]);                /*  Reset volume ... jdl */
/*  done ... jdl  */

/*  old version
	result = fopen(name, mode);
	if (!result) {
		perror(name);
		exit(1);
	}
*/

    return(result);
}

int eoln(f)
FILE *f;
{
    register int c;

    if (feof(f)) return(1);
    c = getc(f);
    if (c != EOF)
	(void) ungetc(c, f);
    return (c == '\n' || c == EOF);
}

void lineread(f, size)
FILE *f;
int size;
{
    extern long last;
    int in;

    last = 0;
    while (last < size && (in = getc(f)) != EOF && in != '\n') {
#ifdef	NONASCII
	buffer[last++] = xord[in];
#else
	buffer[last++] = in;
#endif
    }
    while (in != EOF && in != '\n')	/* Skip past eoln if buffer full */
	(void) getc(f);
}

void setpaths()
{
    extern char *getenv();
    char *p;

    if (p = getenv("TEXINPUTS"))
	(void) strcpy(input_path, p);
    else
	(void) strcpy(input_path, TEXINPUTS);
}


int testaccess(wam, filepath)
int wam, filepath;
{
    char *path = NULL;
    register int ok;
    int f;

    if (filepath == 1)
	path = input_path;
    if (nameoffile[0] == '/')
	path = NULL;
    do {
	packrealnameoffile(&path);
	if (wam == 4)
	    if (access(realnameoffile, 4) == 0) ok = TRUE;
	    else ok = FALSE;
        else {
/*  fake this ... jdl
	    f = creat(realnameoffile, 0666);
	    if (f >= 0) ok = TRUE;
	    else ok = FALSE;
	    if (ok)
		(void) close(f);
*/
		ok = TRUE;
/*  done ... jdl */
	}
    }
    while (!ok && path != NULL);
/*
    if (ok) {
	for (p=realnameoffile; *p; p++);
	while (p < &(realnameoffile[filenamesize]))
	    *p++ = ' ';
    }
*/
    return(ok);
}

static packrealnameoffile(cpp)
char **cpp;
{
    register char *p, *realname;

    realname = realnameoffile;
    if ((p = *cpp)) {
	while ((*p != ':') && *p) {
	    *realname++ = *p++;
	    if (realname == &(realnameoffile[filenamesize-1]))
		break;
	}
	if (*p == '\0') *cpp = NULL;
	else *cpp = p+1;
	*realname++ = '/';
    }
    p = nameoffile;
    while (*p != ' ') {
	if (realname >= &(realnameoffile[filenamesize-1])) {
	    fprintf(stderr, "! Full file name is too long\n");
	    break;
	}
	*realname++ = *p++;
    }
    *realname = '\0';
}

int
getcmdline(buf, n)
char *buf;
{
	strncpy(buf, gargv[1], n);
	return (strlen(buf));
}

_main(argc, argv)
char *argv[];
{
    extern schar history;
    int status;

    gargc = argc;
    gargv = argv;
    setpaths();
    main_body();
    status = (history != 0);
	exit(status);
}
