#include "bibtex.h"
#include "bibtex.p"
#include "globals.h"
#include "coerce.h"

printanewline () {
    (void) putc('\n',  logfile );
  (void) putc('\n',  stdout );
} 
markwarning () {
    if ( ( history == 1 ) ) 
  incr ( errcount ) ; 
  else if ( ( history == 0 ) ) 
  {
    history = 1 ; 
    errcount = 1 ; 
  } 
} 
markerror () {
    if ( ( history < 2 ) ) 
  {
    history = 2 ; 
    errcount = 1 ; 
  } 
  else incr ( errcount ) ; 
} 
markfatal () {
    history = 3 ; 
} 
printoverflow () {
    { 
    (void) Fputs( logfile ,  "Sorry---you've exceeded BibTeX's " ) ; 
    (void) Fputs( stdout ,  "Sorry---you've exceeded BibTeX's " ) ; 
  } 
  markfatal () ; 
} 
printconfusion () {
    { 
    (void) fprintf( logfile , "%s\n",  "---this can't happen" ) ; 
    (void) fprintf( stdout , "%s\n",  "---this can't happen" ) ; 
  } 
  {
    (void) fprintf( logfile , "%s\n",  "*Please notify the BibTeX maintainer*" ) ; 
    (void) fprintf( stdout , "%s\n",  "*Please notify the BibTeX maintainer*" ) ; 
  } 
  markfatal () ; 
} 
bufferoverflow () {
    { 
    printoverflow () ; 
    {
      (void) fprintf( logfile , "%s%ld\n",  "buffer size " , (long)bufsize ) ; 
      (void) fprintf( stdout , "%s%ld\n",  "buffer size " , (long)bufsize ) ; 
    } 
    longjmp(jmp9998,1) ; 
  } 
} 
boolean zinputln ( f ) 
alphafile f ; 
{/* 15 */ register boolean Result; last = 0 ; 
  if ( eof ( f ) ) 
  Result = false ; 
  else {
      
    lineread ( f , bufsize ) ; 
    if ( last >= bufsize ) 
    {
      printoverflow () ; 
      {
	(void) fprintf( logfile , "%s%ld\n",  "buffer size " , (long)bufsize ) ; 
	(void) fprintf( stdout , "%s%ld\n",  "buffer size " , (long)bufsize ) ; 
      } 
      longjmp(jmp9998,1) ; 
    } 
    while ( ( last > 0 ) ) if ( lexclass [ buffer [ last - 1 ] ] == 1 ) 
    decr ( last ) ; 
    else goto lab15 ; 
    lab15: Result = true ; 
  } 
  return(Result) ; 
} 
zoutpoolstr ( f , s ) 
alphafile f ; 
strnumber s ; 
{poolpointer i  ; 
  if ( ( ( s < 0 ) || ( s >= strptr + 3 ) || ( s >= maxstrings ) ) ) 
  {
    {
      (void) fprintf( logfile , "%s%ld",  "Illegal string number:" , (long)s ) ; 
      (void) fprintf( stdout , "%s%ld",  "Illegal string number:" , (long)s ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
  {register integer for_end; i = strstart [ s ] ; for_end = strstart [ s + 1 
  ] - 1 ; if ( i <= for_end) do 
    (void) putc( xchr [ strpool [ i ] ] ,  f );
  while ( i++ < for_end ) ; } 
} 
zprintapoolstr ( s ) 
strnumber s ; 
{outpoolstr ( stdout , s ) ; 
  outpoolstr ( logfile , s ) ; 
} 
pooloverflow () {
    { 
    printoverflow () ; 
    {
      (void) fprintf( logfile , "%s%ld\n",  "pool size " , (long)poolsize ) ; 
      (void) fprintf( stdout , "%s%ld\n",  "pool size " , (long)poolsize ) ; 
    } 
    longjmp(jmp9998,1) ; 
  } 
} 
filenmsizeoverflow () {
    { 
    printoverflow () ; 
    {
      (void) fprintf( logfile , "%s%ld\n",  "file name size " , (long)1024 ) ; 
      (void) fprintf( stdout , "%s%ld\n",  "file name size " , (long)1024 ) ; 
    } 
    longjmp(jmp9998,1) ; 
  } 
} 
zouttoken ( f ) 
alphafile f ; 
{bufpointer i  ; 
  i = bufptr1 ; 
  while ( ( i < bufptr2 ) ) {
      
    (void) putc( xchr [ buffer [ i ] ] ,  f );
    incr ( i ) ; 
  } 
} 
printatoken () {
    outtoken ( stdout ) ; 
  outtoken ( logfile ) ; 
} 
printbadinputline () {
    bufpointer bfptr  ; 
  {
    (void) Fputs( logfile ,  " : " ) ; 
    (void) Fputs( stdout ,  " : " ) ; 
  } 
  bfptr = 0 ; 
  while ( ( bfptr < bufptr2 ) ) {
      
    if ( ( lexclass [ buffer [ bfptr ] ] == 1 ) ) 
    {
      (void) putc( xchr [ 32 ] ,  logfile );
      (void) putc( xchr [ 32 ] ,  stdout );
    } 
    else {
	
      (void) putc( xchr [ buffer [ bfptr ] ] ,  logfile );
      (void) putc( xchr [ buffer [ bfptr ] ] ,  stdout );
    } 
    incr ( bfptr ) ; 
  } 
  printanewline () ; 
  {
    (void) Fputs( logfile ,  " : " ) ; 
    (void) Fputs( stdout ,  " : " ) ; 
  } 
  bfptr = 0 ; 
  while ( ( bfptr < bufptr2 ) ) {
      
    {
      (void) putc( xchr [ 32 ] ,  logfile );
      (void) putc( xchr [ 32 ] ,  stdout );
    } 
    incr ( bfptr ) ; 
  } 
  bfptr = bufptr2 ; 
  while ( ( bfptr < last ) ) {
      
    if ( ( lexclass [ buffer [ bfptr ] ] == 1 ) ) 
    {
      (void) putc( xchr [ 32 ] ,  logfile );
      (void) putc( xchr [ 32 ] ,  stdout );
    } 
    else {
	
      (void) putc( xchr [ buffer [ bfptr ] ] ,  logfile );
      (void) putc( xchr [ buffer [ bfptr ] ] ,  stdout );
    } 
    incr ( bfptr ) ; 
  } 
  printanewline () ; 
  bfptr = 0 ; 
  while ( ( ( bfptr < bufptr2 ) && ( lexclass [ buffer [ bfptr ] ] == 1 ) ) ) 
  incr ( bfptr ) ; 
  if ( ( bfptr == bufptr2 ) ) 
  {
    (void) fprintf( logfile , "%s\n",  "(Error may have been on previous line)" ) ; 
    (void) fprintf( stdout , "%s\n",  "(Error may have been on previous line)" ) ; 
  } 
  markerror () ; 
} 
printskippingwhateve () {
    { 
    (void) Fputs( logfile ,  "I'm skipping whatever remains of this " ) ; 
    (void) Fputs( stdout ,  "I'm skipping whatever remains of this " ) ; 
  } 
} 
samtoolongfilenamepr () {
    (void) Fputs( stdout ,  "File name `" ) ; 
  nameptr = 0 ; 
  while ( ( nameptr < auxnamelength ) ) {
      
    (void) putc( nameoffile [ nameptr ] ,  stdout );
    incr ( nameptr ) ; 
  } 
  (void) fprintf( stdout , "%s\n",  "' is too long" ) ; 
} 
samwrongfilenameprin () {
    (void) Fputs( stdout ,  "I couldn't open file name `" ) ; 
  nameptr = 0 ; 
  while ( ( nameptr < namelength ) ) {
      
    (void) putc( nameoffile [ nameptr ] ,  stdout );
    incr ( nameptr ) ; 
  } 
  (void) fprintf( stdout , "%c\n",  '\'' ) ; 
} 
printauxname () {
    printapoolstr ( auxlist [ auxptr ] ) ; 
  printanewline () ; 
} 
auxerrprint () {
    { 
    (void) fprintf( logfile , "%s%ld%s",  "---line " , (long)auxlnstack [ auxptr ] , " of file " ) ; 
    (void) fprintf( stdout , "%s%ld%s",  "---line " , (long)auxlnstack [ auxptr ] , " of file " ) ; 
  } 
  printauxname () ; 
  printbadinputline () ; 
  printskippingwhateve () ; 
  {
    (void) fprintf( logfile , "%s\n",  "command" ) ; 
    (void) fprintf( stdout , "%s\n",  "command" ) ; 
  } 
} 
zauxerrillegalanother ( cmdnum ) 
integer cmdnum ; 
{{
    
    (void) Fputs( logfile ,  "Illegal, another \\bib" ) ; 
    (void) Fputs( stdout ,  "Illegal, another \\bib" ) ; 
  } 
  switch ( ( cmdnum ) ) 
  {case 0 : 
    {
      (void) Fputs( logfile ,  "data" ) ; 
      (void) Fputs( stdout ,  "data" ) ; 
    } 
    break ; 
  case 1 : 
    {
      (void) Fputs( logfile ,  "style" ) ; 
      (void) Fputs( stdout ,  "style" ) ; 
    } 
    break ; 
    default: 
    {
      {
	(void) Fputs( logfile ,  "Illegal auxiliary-file command" ) ; 
	(void) Fputs( stdout ,  "Illegal auxiliary-file command" ) ; 
      } 
      printconfusion () ; 
      longjmp(jmp9998,1) ; 
    } 
    break ; 
  } 
  {
    (void) Fputs( logfile ,  " command" ) ; 
    (void) Fputs( stdout ,  " command" ) ; 
  } 
} 
auxerrnorightbracepr () {
    { 
    (void) fprintf( logfile , "%s%c%c",  "No \"" , xchr [ 125 ] , '"' ) ; 
    (void) fprintf( stdout , "%s%c%c",  "No \"" , xchr [ 125 ] , '"' ) ; 
  } 
} 
auxerrstuffafterrigh () {
    { 
    (void) fprintf( logfile , "%s%c%c",  "Stuff after \"" , xchr [ 125 ] , '"' ) ; 
    (void) fprintf( stdout , "%s%c%c",  "Stuff after \"" , xchr [ 125 ] , '"' ) ; 
  } 
} 
auxerrwhitespaceinar () {
    { 
    (void) Fputs( logfile ,  "White space in argument" ) ; 
    (void) Fputs( stdout ,  "White space in argument" ) ; 
  } 
} 
printbibname () {
    printapoolstr ( biblist [ bibptr ] ) ; 
  printapoolstr ( sbibextension ) ; 
  printanewline () ; 
} 
printbstname () {
    printapoolstr ( bststr ) ; 
  printapoolstr ( sbstextension ) ; 
  printanewline () ; 
} 
hashciteconfusion () {
    { 
    {
      (void) Fputs( logfile ,  "Cite hash error" ) ; 
      (void) Fputs( stdout ,  "Cite hash error" ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
} 
zcheckciteoverflow ( lastcite ) 
citenumber lastcite ; 
{if ( ( lastcite == maxcites ) ) 
  {
    printapoolstr ( hashtext [ citeloc ] ) ; 
    {
      (void) fprintf( logfile , "%s\n",  " is the key:" ) ; 
      (void) fprintf( stdout , "%s\n",  " is the key:" ) ; 
    } 
    {
      printoverflow () ; 
      {
	(void) fprintf( logfile , "%s%ld\n",  "number of cite keys " , (long)maxcites ) ; 
	(void) fprintf( stdout , "%s%ld\n",  "number of cite keys " , (long)maxcites ) ; 
      } 
      longjmp(jmp9998,1) ; 
    } 
  } 
} 
auxend1errprint () {
    { 
    (void) Fputs( logfile ,  "I found no " ) ; 
    (void) Fputs( stdout ,  "I found no " ) ; 
  } 
} 
auxend2errprint () {
    { 
    (void) Fputs( logfile ,  "---while reading file " ) ; 
    (void) Fputs( stdout ,  "---while reading file " ) ; 
  } 
  printauxname () ; 
  markerror () ; 
} 
bstlnnumprint () {
    { 
    (void) fprintf( logfile , "%s%ld%s",  "--line " , (long)bstlinenum , " of file " ) ; 
    (void) fprintf( stdout , "%s%ld%s",  "--line " , (long)bstlinenum , " of file " ) ; 
  } 
  printbstname () ; 
} 
bsterrprintandlookfo () {
    { 
    (void) putc( '-' ,  logfile );
    (void) putc( '-' ,  stdout );
  } 
  bstlnnumprint () ; 
  printbadinputline () ; 
  while ( ( last != 0 ) ) if ( ( ! inputln ( bstfile ) ) ) 
  longjmp(jmp32,1) ; 
  else incr ( bstlinenum ) ; 
  bufptr2 = last ; 
} 
bstwarnprint () {
    bstlnnumprint () ; 
  markwarning () ; 
} 
eatbstprint () {
    { 
    (void) Fputs( logfile ,  "Illegal end of style file in command: " ) ; 
    (void) Fputs( stdout ,  "Illegal end of style file in command: " ) ; 
  } 
} 
unknwnfunctionclassc () {
    { 
    {
      (void) Fputs( logfile ,  "Unknown function class" ) ; 
      (void) Fputs( stdout ,  "Unknown function class" ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
} 
zprintfnclass ( fnloc ) 
hashloc fnloc ; 
{switch ( ( fntype [ fnloc ] ) ) 
  {case 0 : 
    {
      (void) Fputs( logfile ,  "built-in" ) ; 
      (void) Fputs( stdout ,  "built-in" ) ; 
    } 
    break ; 
  case 1 : 
    {
      (void) Fputs( logfile ,  "wizard-defined" ) ; 
      (void) Fputs( stdout ,  "wizard-defined" ) ; 
    } 
    break ; 
  case 2 : 
    {
      (void) Fputs( logfile ,  "integer-literal" ) ; 
      (void) Fputs( stdout ,  "integer-literal" ) ; 
    } 
    break ; 
  case 3 : 
    {
      (void) Fputs( logfile ,  "string-literal" ) ; 
      (void) Fputs( stdout ,  "string-literal" ) ; 
    } 
    break ; 
  case 4 : 
    {
      (void) Fputs( logfile ,  "field" ) ; 
      (void) Fputs( stdout ,  "field" ) ; 
    } 
    break ; 
  case 5 : 
    {
      (void) Fputs( logfile ,  "integer-entry-variable" ) ; 
      (void) Fputs( stdout ,  "integer-entry-variable" ) ; 
    } 
    break ; 
  case 6 : 
    {
      (void) Fputs( logfile ,  "string-entry-variable" ) ; 
      (void) Fputs( stdout ,  "string-entry-variable" ) ; 
    } 
    break ; 
  case 7 : 
    {
      (void) Fputs( logfile ,  "integer-global-variable" ) ; 
      (void) Fputs( stdout ,  "integer-global-variable" ) ; 
    } 
    break ; 
  case 8 : 
    {
      (void) Fputs( logfile ,  "string-global-variable" ) ; 
      (void) Fputs( stdout ,  "string-global-variable" ) ; 
    } 
    break ; 
    default: 
    unknwnfunctionclassc () ; 
    break ; 
  } 
} 
#ifdef TRACE
ztraceprfnclass ( fnloc ) 
hashloc fnloc ; 
{switch ( ( fntype [ fnloc ] ) ) 
  {case 0 : 
    {
      (void) Fputs( logfile ,  "built-in" ) ; 
    } 
    break ; 
  case 1 : 
    {
      (void) Fputs( logfile ,  "wizard-defined" ) ; 
    } 
    break ; 
  case 2 : 
    {
      (void) Fputs( logfile ,  "integer-literal" ) ; 
    } 
    break ; 
  case 3 : 
    {
      (void) Fputs( logfile ,  "string-literal" ) ; 
    } 
    break ; 
  case 4 : 
    {
      (void) Fputs( logfile ,  "field" ) ; 
    } 
    break ; 
  case 5 : 
    {
      (void) Fputs( logfile ,  "integer-entry-variable" ) ; 
    } 
    break ; 
  case 6 : 
    {
      (void) Fputs( logfile ,  "string-entry-variable" ) ; 
    } 
    break ; 
  case 7 : 
    {
      (void) Fputs( logfile ,  "integer-global-variable" ) ; 
    } 
    break ; 
  case 8 : 
    {
      (void) Fputs( logfile ,  "string-global-variable" ) ; 
    } 
    break ; 
    default: 
    unknwnfunctionclassc () ; 
    break ; 
  } 
} 
#endif /* TRACE */
idscanningconfusion () {
    { 
    {
      (void) Fputs( logfile ,  "Identifier scanning error" ) ; 
      (void) Fputs( stdout ,  "Identifier scanning error" ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
} 
bstidprint () {
    if ( ( scanresult == 0 ) ) 
  {
    (void) fprintf( logfile , "%c%c%s%ld",  '"' , xchr [ buffer [ bufptr2 ] ] ,     "\" begins identifier, (long)command: " ) ; 
    (void) fprintf( stdout , "%c%c%s%ld",  '"' , xchr [ buffer [ bufptr2 ] ] ,     "\" begins identifier, (long)command: " ) ; 
  } 
  else if ( ( scanresult == 2 ) ) 
  {
    (void) fprintf( logfile , "%c%c%s%ld",  '"' , xchr [ buffer [ bufptr2 ] ] ,     "\" immediately follows identifier, (long)command: " ) ; 
    (void) fprintf( stdout , "%c%c%s%ld",  '"' , xchr [ buffer [ bufptr2 ] ] ,     "\" immediately follows identifier, (long)command: " ) ; 
  } 
  else idscanningconfusion () ; 
} 
bstleftbraceprint () {
    { 
    (void) fprintf( logfile , "%c%c%s",  '"' , xchr [ 123 ] , "\" is missing in command: " ) ; 
    (void) fprintf( stdout , "%c%c%s",  '"' , xchr [ 123 ] , "\" is missing in command: " ) ; 
  } 
} 
bstrightbraceprint () {
    { 
    (void) fprintf( logfile , "%c%c%s",  '"' , xchr [ 125 ] , "\" is missing in command: " ) ; 
    (void) fprintf( stdout , "%c%c%s",  '"' , xchr [ 125 ] , "\" is missing in command: " ) ; 
  } 
} 
zalreadyseenfunctionp ( seenfnloc ) 
hashloc seenfnloc ; 
{/* 10 */ printapoolstr ( hashtext [ seenfnloc ] ) ; 
  {
    (void) Fputs( logfile ,  " is already a type \"" ) ; 
    (void) Fputs( stdout ,  " is already a type \"" ) ; 
  } 
  printfnclass ( seenfnloc ) ; 
  {
    (void) fprintf( logfile , "%s\n",  "\" function name" ) ; 
    (void) fprintf( stdout , "%s\n",  "\" function name" ) ; 
  } 
  {
    bsterrprintandlookfo () ; 
    goto lab10 ; 
  } 
  lab10: ; 
} 
singlfnoverflow () {
    { 
    printoverflow () ; 
    {
      (void) fprintf( logfile , "%s%ld\n",  "single function space " , (long)singlefnspace ) ; 
      (void) fprintf( stdout , "%s%ld\n",  "single function space " , (long)singlefnspace ) ; 
    } 
    longjmp(jmp9998,1) ; 
  } 
} 
biblnnumprint () {
    { 
    (void) fprintf( logfile , "%s%ld%s",  "--line " , (long)biblinenum , " of file " ) ; 
    (void) fprintf( stdout , "%s%ld%s",  "--line " , (long)biblinenum , " of file " ) ; 
  } 
  printbibname () ; 
} 
biberrprint () {
    { 
    (void) putc( '-' ,  logfile );
    (void) putc( '-' ,  stdout );
  } 
  biblnnumprint () ; 
  printbadinputline () ; 
  printskippingwhateve () ; 
  if ( ( atbibcommand ) ) 
  {
    (void) fprintf( logfile , "%s\n",  "command" ) ; 
    (void) fprintf( stdout , "%s\n",  "command" ) ; 
  } 
  else {
      
    (void) fprintf( logfile , "%s\n",  "entry" ) ; 
    (void) fprintf( stdout , "%s\n",  "entry" ) ; 
  } 
} 
bibwarnprint () {
    biblnnumprint () ; 
  markwarning () ; 
} 
zcheckfieldoverflow ( totalfields ) 
integer totalfields ; 
{if ( ( totalfields > maxfields ) ) 
  {
    {
      (void) fprintf( logfile , "%ld%s\n",  (long)totalfields , " fields:" ) ; 
      (void) fprintf( stdout , "%ld%s\n",  (long)totalfields , " fields:" ) ; 
    } 
    {
      printoverflow () ; 
      {
	(void) fprintf( logfile , "%s%ld\n",  "total number of fields " , (long)maxfields ) ; 
	(void) fprintf( stdout , "%s%ld\n",  "total number of fields " , (long)maxfields ) ; 
      } 
      longjmp(jmp9998,1) ; 
    } 
  } 
} 
eatbibprint () {
    /* 10 */ { 
    {
      (void) Fputs( logfile ,  "Illegal end of database file" ) ; 
      (void) Fputs( stdout ,  "Illegal end of database file" ) ; 
    } 
    biberrprint () ; 
    goto lab10 ; 
  } 
  lab10: ; 
} 
zbiboneoftwoprint ( char1 , char2 ) 
ASCIIcode char1 , char2 ; 
{/* 10 */ {
    
    {
      (void) fprintf( logfile , "%s%c%s%c%c",  "I was expecting a `" , xchr [ char1 ] , "' or a `" ,       xchr [ char2 ] , '\'' ) ; 
      (void) fprintf( stdout , "%s%c%s%c%c",  "I was expecting a `" , xchr [ char1 ] , "' or a `" ,       xchr [ char2 ] , '\'' ) ; 
    } 
    biberrprint () ; 
    goto lab10 ; 
  } 
  lab10: ; 
} 
bibequalssignprint () {
    /* 10 */ { 
    {
      (void) fprintf( logfile , "%s%c%c",  "I was expecting an \"" , xchr [ 61 ] , '"' ) ; 
      (void) fprintf( stdout , "%s%c%c",  "I was expecting an \"" , xchr [ 61 ] , '"' ) ; 
    } 
    biberrprint () ; 
    goto lab10 ; 
  } 
  lab10: ; 
} 
bibunbalancedbracesp () {
    /* 10 */ { 
    {
      (void) Fputs( logfile ,  "Unbalanced braces" ) ; 
      (void) Fputs( stdout ,  "Unbalanced braces" ) ; 
    } 
    biberrprint () ; 
    goto lab10 ; 
  } 
  lab10: ; 
} 
bibfieldtoolongprint () {
    /* 10 */ { 
    {
      (void) fprintf( logfile , "%s%ld%s",  "Your field is more than " , (long)bufsize , " characters" ) 
      ; 
      (void) fprintf( stdout , "%s%ld%s",  "Your field is more than " , (long)bufsize , " characters" ) 
      ; 
    } 
    biberrprint () ; 
    goto lab10 ; 
  } 
  lab10: ; 
} 
macrowarnprint () {
    { 
    (void) Fputs( logfile ,  "Warning--string name \"" ) ; 
    (void) Fputs( stdout ,  "Warning--string name \"" ) ; 
  } 
  printatoken () ; 
  {
    (void) Fputs( logfile ,  "\" is " ) ; 
    (void) Fputs( stdout ,  "\" is " ) ; 
  } 
} 
